import java.sql.ResultSet;



public class GetRegressionInfo {
	private String regression;
	private DiagnosticTest diagT;
	private SingleClientTest scT;
	private MultipleClientTest mcT;
	private dbConnection dbCon;
	private String[] clientList;
	
	public GetRegressionInfo(String reg){
		ResultSet rs,rs1;
		RunRegression rr;
		
		regression = reg;
		dbCon = new dbConnection();
		diagT = new DiagnosticTest();
		scT = new SingleClientTest();
		mcT = new MultipleClientTest();
		String cmd = "Select * from config_info where entry_name  = \"" + reg +"\"";
		//System.out.println(cmd);
		rs = dbCon.createExecuteQuery(cmd);
		rr = parseResultSet(rs);
		diagT = rr.getDiagnosticTest();
		scT = rr.getSingleClientTest();
		mcT = rr.getMultipleClientTest();
		
		cmd = "Select distinct client_name from benchmark_perf_info where entry_name =\"" +
				 reg + "\" and client_name != \"NULL\"";
		rs = dbCon.createExecuteQuery(cmd);
		
		cmd = "Select count(distinct client_name) from benchmark_perf_info where entry_name =\"" +
		 reg + "\" and client_name != \"NULL\"";
		rs1 = dbCon.createExecuteQuery(cmd);
		int i=0;
		try{
			int numClients=0;
			while(rs1 != null && rs1.next()){
				numClients = rs1.getInt(1);
				clientList = new String [numClients];
			}
			while(rs!=null && rs.next()){
		        
				clientList[i] = rs.getString("client_name");
		       System.out.println("client Name->" + clientList[i] + "position" + i);
		       i++;
		      }
			}
			catch(Exception e){
				e.printStackTrace();
			}
		
	}
	
	private RunRegression parseResultSet(ResultSet rs){
		RunRegression rr = new RunRegression();
		DiagnosticTest dg = new DiagnosticTest();
		SingleClientTest st = new SingleClientTest();
		MultipleClientTest mt = new MultipleClientTest();
		try{
			while(rs.next()){
				if(rs.getInt("stage_zero") == 1) {
					dg.setRunDiagnostic(true);
				}
				else {
					dg.setRunDiagnostic(true);
				}
				if(rs.getInt("disk_perf") == 1){
					dg.setRunDiskPerf(true);
				}
				else{
					dg.setRunDiskPerf(false);
				}
				if(rs.getInt("network_perf") == 1){
					dg.setRuniPerf(true);
				}
				else{
					dg.setRuniPerf(false);
				}
				if(rs.getInt("netSat") == 1){
					dg.setRunNetSat(true);
				}
				else{
					dg.setRunNetSat(false);
				}
				dg.setNumberOfRuns(rs.getInt("stageZero_num_runs"));
				
				
				
				// stage One
				if(rs.getInt("stage_one") == 1){
					rr.setRunStageOne(true);
				}
				else{
					rr.setRunStageOne(false);
				}
				if(rs.getInt("single_client") == 1){
					st.setRunSingleClientTest(true);
				}
				else{
					st.setRunSingleClientTest(false);
				}
				
				st.setNumberOfRuns(rs.getInt("singleClient_num_runs"));
				
				if(rs.getInt("autoreport") == 1){
					st.setAutoReportTest(true);
				}
				else{
					st.setAutoReportTest(false);
				}
				if(rs.getInt("large_files") == 1){
					st.setRunLargeFileTest(true);
				}
				else{
					st.setRunLargeFileTest(false);
				}
				
				st.setMaxLargeFileSize(rs.getDouble("max_largefile"));
				st.setMinLargeFileSize(rs.getDouble("min_largefile"));
				st.setLargeFileRecordSize(rs.getDouble("largefile_recordsize"));
				
				if(rs.getInt("small_files") == 1){
					st.setRunSmallFileTest(true);
				}
				else{
					st.setRunSmallFileTest(false);
				}
				st.setMinSmallFileSize(rs.getInt("min_smallfile"));
				st.setMaxSmallFileSize(rs.getInt("max_smallfile"));
				st.setSmallFileRecordSize(rs.getDouble("smallfile_recordsize"));
				
				if(rs.getInt("multiple_clients") == 1){
					mt.setRunMultipleClientTest(true);
				}
				else{
					mt.setRunMultipleClientTest(false);
				}
				mt.setNumberOfRuns(rs.getInt("multipleClient_num_runs"));
				mt.setMinNumberOfClients(rs.getInt("min_numclients"));
				mt.setMaxNumberOfClients(rs.getInt("max_numclients"));
				mt.setMinFileSize(rs.getDouble("min_multiclient_filesize"));
				mt.setMaxFileSize(rs.getDouble("max_multiclient_filesize"));
				mt.setMinRecordSize(rs.getDouble("multiclient_min_recordsize"));
				mt.setMaxRecordSize(rs.getDouble("multiclient_max_recordsize"));
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		rr.setDiagnosticTest(dg);
		rr.setMultipleClientTest(mt);
		rr.setSingleClientTest(st);
		
		return rr;
	}
	
	public DiagnosticTest getDiagnosticResults(){
		return diagT;
	}
	
	public SingleClientTest getSingleClientResults(){
		return scT;
	}
	
	public MultipleClientTest getMultipleCLientResults(){
		return mcT;
	}
	
	public String getRegressionName(){
		return regression;
	}
	
	public String[] getClientList(){
		for(int i=0; i<clientList.length; i++){
			System.out.println(clientList[i]);	
		}
			
		return clientList;
	}
	
}
