import java.awt.*;

import javax.swing.*;

public class GraphSelectionPanel extends JPanel {

	private CompareMetaData cmd;
	private GetRegressionInfo cmd1;
	private MyCheckBox DiskPerformance;
	private MyCheckBox iperf;
	private MyCheckBox netSat;
	private MyCheckBox autoreport;
	private MyCheckBox sclargeFile;
	private MyCheckBox scsmallfile;
	private MyCheckBox readChkBox;
	private MyCheckBox writeChkBox;
	private MyCheckBox mc;
	
	private MyComboBox autoreportcbBox;
	private MyComboBox recordSizeCbBox;
	private MyComboBox fileSizeCbBox;
	private MyComboBox clientSelectionCbBox;
	private MyComboBox clientSelectionCbBox1;
	private MyComboBox clientSelectionCbBox2;
	
	private MyPlotButton plotButton;
	
	private JLabel autoreportSelection;
	private JLabel clientSelectionLabel;
	private JLabel clientSelectionLabel1;
	private JLabel clientSelectionLabel2;
	private JLabel multiclientFileSize;
	private JLabel multiclientRecordSize;
	
	private boolean singleRegression;
	
	
	private JPanel checkPanel;
	
	public GraphSelectionPanel(CompareMetaData cm){
		String[] autoReportOptions = { "64K", "128K", "256K", "512K", "1M", "2M", "4M", 
				"8M", "16M", "32M", "64M", "128M", "256M", "512M"};
		cmd = cm;
		singleRegression = false;
		int yLevel = 0;
		int xLevel = 0;
		
		checkPanel = new JPanel(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		plotButton = new MyPlotButton();
		plotButton.setCompareMetaData(cmd);
		
		if(cmd.getDiagnosticResults().getRunDiagnostic() == true){
			
			if(cmd.getDiagnosticResults().getRunNetSat() == true){
				netSat = new MyCheckBox("Net Saturation (netSat)", 15);
				c.gridx = xLevel;
				c.gridy = yLevel++;
				//System.out.println("netsat" + yLevel);
				c.anchor = GridBagConstraints.LINE_START;
				netSat.getMyCheckBox().setToolTipText("NetSat is a network saturation tool that " +
        		"simulates traffic seen in parallel file systems.\n" +
        		"The tool outputs the maximum network bandwidth available for such traffic.\n " +
        		"check this box to view the output of this test.");
				checkPanel.add(netSat.getMyCheckBox(),c);
				plotButton.setnetSat(netSat);
			}
		}
		if(cmd.getSingleClientResults().getRunSingleClientTest() == true){
			clientSelectionLabel1 = new JLabel("Comapre single client results of " +
					"Client1 ");
			clientSelectionLabel2 = new JLabel("with " +
			"Client2 ");
			clientSelectionCbBox1 = new MyComboBox(cmd.getClientList1());
			clientSelectionCbBox2 = new MyComboBox(cmd.getClientList2());
			c.gridx = xLevel;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(clientSelectionLabel1, c);
			c.gridx = xLevel+1;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_END;
			checkPanel.add(clientSelectionCbBox1.getMyComboBox(), c);
			plotButton.setClientNameCbBox(clientSelectionCbBox1);
			c.gridx = xLevel+2;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(clientSelectionLabel2, c);
			c.gridx = xLevel+3;
			c.gridy = yLevel++;
			c.anchor = GridBagConstraints.LINE_END;
			checkPanel.add(clientSelectionCbBox2.getMyComboBox(), c);
			plotButton.setClientNameCbBox1(clientSelectionCbBox2);			
			
			if(cmd.getSingleClientResults().getAutoReportTest() == true){
				autoreport = new MyCheckBox("AutoReport", 15);
				autoreportSelection = new JLabel("File Size");
				autoreportcbBox = new MyComboBox(autoReportOptions);
				readChkBox = new MyCheckBox("Read", 15);
				writeChkBox = new MyCheckBox("Write", 15);
				c.gridx = xLevel;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_START;
				checkPanel.add(autoreport.getMyCheckBox(), c);
				plotButton.setautoreport(autoreport);
				c.gridx = xLevel + 1;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_START;
				checkPanel.add(autoreportSelection, c);
				c.gridx = xLevel + 2;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_END;
				checkPanel.add(autoreportcbBox.getMyComboBox(), c);
				plotButton.setautoreportcbBox(autoreportcbBox);
				c.gridx = xLevel + 3;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_END;
				checkPanel.add(readChkBox.getMyCheckBox(), c);
				plotButton.setreadChkBox(readChkBox);
				c.gridx = xLevel + 4;
				c.gridy = yLevel++;
				c.anchor = GridBagConstraints.LINE_END;
				checkPanel.add(writeChkBox.getMyCheckBox(), c);
				plotButton.setwriteChkBox(writeChkBox);
				//System.out.println("autoreport" + yLevel);
			}
			if(cmd.getSingleClientResults().getRunSingleClientTest() == true){
				if(cmd.getSingleClientResults().getRunLargeFileTest() == true){
					sclargeFile = new MyCheckBox("Single Client - Large File", 15);
					c.gridx = xLevel;
					c.gridy = yLevel++;
					c.anchor = GridBagConstraints.LINE_START;
					checkPanel.add(sclargeFile.getMyCheckBox(), c);
					plotButton.setsclargeFile(sclargeFile);
				}
				if(cmd.getSingleClientResults().getRunSmallFileTest() == true){
					scsmallfile = new MyCheckBox("Single Client - Small File", 15);
					c.gridx = xLevel;
					c.gridy = yLevel++;
					c.anchor = GridBagConstraints.LINE_START;
					checkPanel.add(scsmallfile.getMyCheckBox(), c);
					plotButton.setscsmallfile(scsmallfile);
				}
			}
		}
		if(cmd.getMultipleCLientResults().getRunMultipleClientsTest() == true){
			mc = new MyCheckBox("Multiple Clients", 15);
			String []recordsizelist = Utils.generateSizeInfoString(
						cmd.getMultipleCLientResults().getMinRecordSize(),
						cmd.getMultipleCLientResults().getMaxRecordSize());
			recordSizeCbBox = new MyComboBox(recordsizelist);
			String []filesizelist = Utils.generateSizeInfoString(
						cmd.getMultipleCLientResults().getMinFileSize(),
						cmd.getMultipleCLientResults().getMaxFileSize());
			fileSizeCbBox = new MyComboBox(filesizelist);
			
			multiclientFileSize = new JLabel("File Size");
			multiclientRecordSize = new JLabel("Record Size");
			
			c.gridx = xLevel;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(mc.getMyCheckBox(), c);
			plotButton.setmc(mc);
			
			c.gridx = xLevel + 1;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(multiclientFileSize, c);
			
			c.gridx = xLevel + 2;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(fileSizeCbBox.getMyComboBox(), c);
			plotButton.setfileSizeCbBox(fileSizeCbBox);
			
			c.gridx = xLevel + 3;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			c.insets = new Insets(0, 10, 0, 0);
			checkPanel.add(multiclientRecordSize, c);
			
			c.gridx = xLevel + 4;
			c.gridy = yLevel++;
			c.insets = new Insets(0, 0, 0, 0);
			c.anchor = GridBagConstraints.LINE_END;
			checkPanel.add(recordSizeCbBox.getMyComboBox(), c);
			plotButton.setrecordSizeCbBox(recordSizeCbBox);
		}
		
		c.gridx = xLevel + 3;
		c.gridy = yLevel+2;
		c.anchor = GridBagConstraints.LINE_START;
		c.insets = new Insets(10, 10, 0, 0);
		checkPanel.add(plotButton.getMyPlotButton(), c);
		
		   	setSize(1000, 500);
		    add(checkPanel, BorderLayout.LINE_START);
	        setBorder(BorderFactory.createEmptyBorder(40,40,40,40));
		   	setVisible(true);
					
	}
	
	public GraphSelectionPanel(GetRegressionInfo cm){
		String[] autoReportOptions = { "64K", "128K", "256K", "512K", "1M", "2M", "4M", 
				"8M", "16M", "32M", "64M", "128M", "256M", "512M"};
		int yLevel = 0;
		int xLevel = 0;
		cmd1 = cm;
		singleRegression = true;
		checkPanel = new JPanel(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		plotButton = new MyPlotButton();
		plotButton.setRegressionInfo(cmd1);
		
		// stage zero
		if(cmd1.getDiagnosticResults().getRunDiagnostic() == true){
			if(cmd1.getDiagnosticResults().getRunDiskPerf() == true){
				DiskPerformance = new MyCheckBox("Disk Performance", 15);
				c.gridx = xLevel;
				c.gridy = yLevel++;
				c.anchor = GridBagConstraints.LINE_START;
				checkPanel.add(DiskPerformance.getMyCheckBox(), c);
				plotButton.setDiskPerformance(DiskPerformance);
			}
			if(cmd1.getDiagnosticResults().getRuniPerf() == true){
				iperf = new MyCheckBox("Raw Network Performance", 15);
				c.gridx = xLevel;
				c.gridy = yLevel++;
				c.anchor = GridBagConstraints.LINE_START;
				checkPanel.add(iperf.getMyCheckBox(), c);
				plotButton.setiperf(iperf);
			}
			if(cmd1.getDiagnosticResults().getRunNetSat() == true){
				netSat = new MyCheckBox("Net Saturation Tool (NetSat)", 15);
				c.gridx = xLevel;
				c.gridy = yLevel++;
				c.anchor = GridBagConstraints.LINE_START;
				netSat.getMyCheckBox().setToolTipText("NetSat is a network saturation tool that " +
		        		"simulates traffic seen in parallel file systems.\n" +
		        		"The tool outputs the maximum network bandwidth available for such traffic.\n " +
		        		"Check this box to view the output of this test.");
				checkPanel.add(netSat.getMyCheckBox(), c);
				plotButton.setnetSat(netSat);
			}
		}
		
		// single client
		if(cmd1.getSingleClientResults().getRunSingleClientTest() == true){
			clientSelectionLabel = new JLabel("Client");
			clientSelectionCbBox = new MyComboBox(cmd1.getClientList());
			c.gridx = xLevel;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(clientSelectionLabel, c);
			c.gridx = xLevel+1;
			c.gridy = yLevel++;
			c.anchor = GridBagConstraints.LINE_END;
			checkPanel.add(clientSelectionCbBox.getMyComboBox(), c);
			plotButton.setClientNameCbBox(clientSelectionCbBox);
			
			if(cmd1.getSingleClientResults().getAutoReportTest() == true){
				autoreport = new MyCheckBox("AutoReport", 15);
				autoreportSelection = new JLabel("File Size");
				
				autoreportcbBox = new MyComboBox(autoReportOptions);
				
				readChkBox = new MyCheckBox("Read", 15);
				writeChkBox = new MyCheckBox("Write", 15);
				c.gridx = xLevel;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_START;
				checkPanel.add(autoreport.getMyCheckBox(), c);
				plotButton.setautoreport(autoreport);
				
				c.gridx = xLevel+1;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_START;
				checkPanel.add(autoreportSelection, c);
				c.gridx = xLevel+2;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_END;
				checkPanel.add(autoreportcbBox.getMyComboBox(), c);
				plotButton.setautoreportcbBox(autoreportcbBox);
				
				c.gridx = xLevel + 5;
				c.gridy = yLevel;
				c.anchor = GridBagConstraints.LINE_END;
				checkPanel.add(readChkBox.getMyCheckBox(), c);
				plotButton.setreadChkBox(readChkBox);
												
				c.gridx = xLevel + 6;
				c.gridy = yLevel++;
				c.anchor = GridBagConstraints.LINE_END;
				checkPanel.add(writeChkBox.getMyCheckBox(), c);
				plotButton.setwriteChkBox(writeChkBox);
			}
			if(cmd1.getSingleClientResults().getRunSingleClientTest() == true){
				if(cmd1.getSingleClientResults().getRunLargeFileTest() == true){
					sclargeFile = new MyCheckBox("Single Client - Large File", 15);
					c.gridx = xLevel;
					c.gridy = yLevel++;
					c.anchor = GridBagConstraints.LINE_START;
					checkPanel.add(sclargeFile.getMyCheckBox(), c);
					plotButton.setsclargeFile(sclargeFile);
				}
				if(cmd1.getSingleClientResults().getRunSmallFileTest() == true){
					scsmallfile = new MyCheckBox("Single Client Small File", 15);
					c.gridx = xLevel;
					c.gridy = yLevel++;
					c.anchor = GridBagConstraints.LINE_START;
					checkPanel.add(scsmallfile.getMyCheckBox(), c);
					plotButton.setscsmallfile(scsmallfile);
				}
			}
		}
		
		// multiclient
		if(cmd1.getMultipleCLientResults().getRunMultipleClientsTest() == true){
			mc = new MyCheckBox("Multiple Clients", 15);
			String []recordsizelist = Utils.generateSizeInfoString(
						cmd1.getMultipleCLientResults().getMinRecordSize(),
						cmd1.getMultipleCLientResults().getMaxRecordSize());
			recordSizeCbBox = new MyComboBox(recordsizelist);
			String []filesizelist = Utils.generateSizeInfoString(
						cmd1.getMultipleCLientResults().getMinFileSize(),
						cmd1.getMultipleCLientResults().getMaxFileSize());
			fileSizeCbBox = new MyComboBox(filesizelist);
			
			multiclientFileSize = new JLabel("File Size");
			multiclientRecordSize = new JLabel("Record Size");
			
			c.gridx = xLevel;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(mc.getMyCheckBox(), c);
			plotButton.setmc(mc);
			
			c.gridx = xLevel + 1;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(multiclientFileSize, c);
			
			c.gridx = xLevel + 2;
			c.gridy = yLevel;
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(fileSizeCbBox.getMyComboBox(), c);
			plotButton.setfileSizeCbBox(fileSizeCbBox);
			
			c.gridx = xLevel + 3;
			c.gridy = yLevel;
			c.insets = new Insets(0, 10, 0, 0);
			c.anchor = GridBagConstraints.LINE_START;
			checkPanel.add(multiclientRecordSize, c);
			
			c.gridx = xLevel + 4;
			c.gridy = yLevel++;
			c.insets = new Insets(0, 0, 0, 0);
			c.anchor = GridBagConstraints.LINE_END;
			checkPanel.add(recordSizeCbBox.getMyComboBox(), c);
			plotButton.setrecordSizeCbBox(recordSizeCbBox);
		}
		
		c.gridx = xLevel + 4;
		c.gridy = yLevel + 3;
		c.anchor = GridBagConstraints.LINE_START;
		c.insets = new Insets(10, 10, 0, 0);
		checkPanel.add(plotButton.getMyPlotButton(), c);
		
		   	setSize(1000, 500);
		    add(checkPanel, BorderLayout.LINE_START);
	        setBorder(BorderFactory.createEmptyBorder(40,40,40,40));
		   	setVisible(true);
					
	}
	
	public void show(){
		JFrame frame = new JFrame("P-Reg Graph Selection Panel");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        this.setOpaque(true); //content panes must be opaque
        frame.setContentPane(this);
        frame.pack();
        frame.setVisible(true);

	}
	
	public boolean getGraphSelectionMode(){
		return singleRegression;
	}
}
