import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

public class MyPlotButton extends JButton implements ActionListener {

	private JButton myPlotButton;
	private CompareMetaData cmd;
	private GetRegressionInfo gri;
	private MyCheckBox DiskPerformance;
	private MyCheckBox iperf;
	private MyCheckBox netSat;
	private MyCheckBox autoreport;
	private MyCheckBox sclargeFile;
	private MyCheckBox scsmallfile;
	private MyCheckBox readChkBox;
	private MyCheckBox writeChkBox;
	private MyCheckBox mc;
	
	private MyComboBox autoreportcbBox;
	private MyComboBox clientNameCbBox;
	private MyComboBox clientNameCbBox1;
	private MyComboBox recordSizeCbBox;
	private MyComboBox fileSizeCbBox;
	
	
	public MyPlotButton(){
		
		myPlotButton = new JButton("Plot");
		DiskPerformance = null;
		iperf = null;
		netSat = null;
		autoreport = null;
		sclargeFile = null;
		scsmallfile = null;
		readChkBox = null;
		writeChkBox = null;
		mc = null;
		autoreportcbBox = null;
		clientNameCbBox = null;
		clientNameCbBox1 = null;
		recordSizeCbBox = null;
		fileSizeCbBox = null;
		cmd = null;
		gri = null;
		
		myPlotButton.addActionListener(this);
		
	}
	
	
	public void setCompareMetaData(CompareMetaData val){
		cmd = val;
	}
	
	public void setRegressionInfo(GetRegressionInfo val){
		gri = val;
	}
	
	public void setDiskPerformance(MyCheckBox val){
		DiskPerformance = val;
	}
	
	public void setiperf(MyCheckBox val){
		iperf = val;
	}
	
	public void setnetSat(MyCheckBox val){
		netSat = val;
	}
	
	public void setautoreport(MyCheckBox val){
		autoreport = val;
	}
	
	public void setsclargeFile(MyCheckBox val){
		sclargeFile = val;
	}
	
	public void setscsmallfile(MyCheckBox val){
		scsmallfile = val;
	}
	
	public void setreadChkBox(MyCheckBox val){
		readChkBox = val;
	}
	
	public void setwriteChkBox(MyCheckBox val){
		writeChkBox = val;
	}
	
	public void setmc(MyCheckBox val){
		mc = val;
	}
	
	public void setautoreportcbBox(MyComboBox val){
		autoreportcbBox = val;
	}
	
	public void setClientNameCbBox(MyComboBox val){
		clientNameCbBox = val;
	}
	
	public void setClientNameCbBox1(MyComboBox val){
		clientNameCbBox1 = val;
	}
	
	public void setrecordSizeCbBox(MyComboBox val){
		recordSizeCbBox = val;
	}
	
	public void setfileSizeCbBox(MyComboBox val){
		fileSizeCbBox = val;
	}
	
	
	public JButton getMyPlotButton(){
		return myPlotButton;
		
	}
	
	/*getter functions for all other variables */
	
	public void actionPerformed(ActionEvent e) {
		
		Plotter plot = new Plotter();
		
		if(cmd != null){
			if(netSat != null && netSat.isSelected()){
				plot.plotNetSatReport(cmd.getRegOneName(), cmd.getRegTwoName());
			}
			if(autoreport != null && autoreport.isSelected()){
				String client1 = (String) clientNameCbBox.getMyComboBox().getSelectedItem();
				String client2 = (String) clientNameCbBox1.getMyComboBox().getSelectedItem();
				double fileSize = Utils.convertFileSize(autoreportcbBox.getIndex(),"64K");
				if(writeChkBox.isSelected()){
					plot.plotAutoReport(cmd.getRegOneName(), cmd.getRegTwoName(), 
							client1, client2, (float)fileSize, "write");	
				}
				if(readChkBox.isSelected()){
					plot.plotAutoReport(cmd.getRegOneName(), cmd.getRegTwoName(), 
							client1, client2, (float)fileSize, "read");	
				}
			}
			if(sclargeFile != null && sclargeFile.isSelected()){
				String client1 = (String) clientNameCbBox.getMyComboBox().getSelectedItem();
				String client2 = (String) clientNameCbBox1.getMyComboBox().getSelectedItem();
				plot.plotVaryingFileSize(cmd.getRegOneName(),cmd.getRegTwoName(), client1 , 
						client2, (float)cmd.getSingleClientResults().getMinLargeFileSize(), 
						(float)cmd.getSingleClientResults().getMaxLargeFileSize(),
						(float)cmd.getSingleClientResults().getLargeFileRecordSize(), "large_write");
				plot.plotVaryingFileSize(cmd.getRegOneName(),cmd.getRegTwoName(), client1, 
						client2, (float)cmd.getSingleClientResults().getMinLargeFileSize(), 
						(float)cmd.getSingleClientResults().getMaxLargeFileSize(),
						(float)cmd.getSingleClientResults().getLargeFileRecordSize(), "large_read");
			}
			if(scsmallfile != null && scsmallfile.isSelected()){
				String client1 = (String) clientNameCbBox.getMyComboBox().getSelectedItem();
				String client2 = (String) clientNameCbBox1.getMyComboBox().getSelectedItem();
				plot.plotVaryingFileSize(cmd.getRegOneName(),cmd.getRegTwoName(), client1 , 
						client2, (float)cmd.getSingleClientResults().getMinSmallFileSize(), 
						(float)cmd.getSingleClientResults().getMaxSmallFileSize(),
						(float)cmd.getSingleClientResults().getSmallFileRecordSize(), "small_write");
				plot.plotVaryingFileSize(cmd.getRegOneName(),cmd.getRegTwoName(), client1 , client2, 
						(float)cmd.getSingleClientResults().getMinSmallFileSize(), 
						(float)cmd.getSingleClientResults().getMaxSmallFileSize(),
						(float)cmd.getSingleClientResults().getSmallFileRecordSize(), "small_read");
			}	
			if(mc !=null && mc.isSelected()){
				
				String tempVal = (String)fileSizeCbBox.getMyComboBox().getSelectedItem();
				int fileSize = (int) Utils.convertFileSize(tempVal);
				tempVal = (String)recordSizeCbBox.getMyComboBox().getSelectedItem();
				int recordSize = (int) Utils.convertFileSize(tempVal);
				
				plot.plotMultipleClientReport(cmd.getRegOneName(),cmd.getRegTwoName() ,
						cmd.getMultipleCLientResults().getMinNumberOfClients(),
						cmd.getMultipleCLientResults().getMaxNumberOfClients(),
						fileSize,recordSize);
			}
			
		}
		
		if(gri != null){
			if(netSat != null && netSat.isSelected()){
				plot.plotNetSatReport(gri.getRegressionName());
			}
			if(DiskPerformance != null && DiskPerformance.isSelected()){
				plot.PlotDiskPerformance(gri.getRegressionName());
			}
			if(iperf !=null && iperf.isSelected()){
				plot.PlotNetworkPerformance(gri.getRegressionName());
			}
			if(autoreport != null && autoreport.isSelected()){
				double fileSize = Utils.convertFileSize(autoreportcbBox.getIndex(),"64K");
				String client = (String) clientNameCbBox.getMyComboBox().getSelectedItem();
				if(writeChkBox.isSelected()){
					plot.plotAutoReport(gri.getRegressionName(), (float)fileSize,"write",client);	
				}
				if(readChkBox.isSelected()){
					plot.plotAutoReport(gri.getRegressionName(), (float)fileSize,"read",client);
				}
			}
			if(sclargeFile !=null && sclargeFile.isSelected()){
				String client = (String) clientNameCbBox.getMyComboBox().getSelectedItem();
				plot.plotVaryingFileSize(gri.getRegressionName(),
						(float)gri.getSingleClientResults().getMinLargeFileSize(),
						(float)gri.getSingleClientResults().getMaxLargeFileSize(),
						(float)gri.getSingleClientResults().getLargeFileRecordSize(), "large_write",
						client);
				plot.plotVaryingFileSize(gri.getRegressionName(),
						(float)gri.getSingleClientResults().getMinLargeFileSize(),
						(float)gri.getSingleClientResults().getMaxLargeFileSize(),
						(float)gri.getSingleClientResults().getLargeFileRecordSize(), "large_read",
						client);
			}
			if(scsmallfile !=null && scsmallfile.isSelected()){
				String client = (String) clientNameCbBox.getMyComboBox().getSelectedItem();
				plot.plotVaryingFileSize(gri.getRegressionName(),
						(float)gri.getSingleClientResults().getMinSmallFileSize(),
						(float)gri.getSingleClientResults().getMaxSmallFileSize(),
						(float)gri.getSingleClientResults().getSmallFileRecordSize(), "small_write",
						client);
				plot.plotVaryingFileSize(gri.getRegressionName(),
						(float)gri.getSingleClientResults().getMinSmallFileSize(),
						(float)gri.getSingleClientResults().getMaxSmallFileSize(),
						(float)gri.getSingleClientResults().getSmallFileRecordSize(), "small_read",
						client);
			}
			if(mc !=null && mc.isSelected()){
				
				String tempVal = (String)fileSizeCbBox.getMyComboBox().getSelectedItem();
				int fileSize = (int) Utils.convertFileSize(tempVal);
				tempVal = (String)recordSizeCbBox.getMyComboBox().getSelectedItem();
				int recordSize = (int) Utils.convertFileSize(tempVal);
				
				plot.plotMultipleClientReport(gri.getRegressionName(), 
						gri.getMultipleCLientResults().getMinNumberOfClients(),
						gri.getMultipleCLientResults().getMaxNumberOfClients(),
						fileSize,recordSize);
			}
		}
		
		
		//
		//plot.plotAutoReport(gri.getRegressionName(), 65536,"write");
		
		/* plot.plotVaryingFileSize(gri.getRegressionName(),
				(float)gri.getSingleClientResults().getMinSmallFileSize(),
				(float)gri.getSingleClientResults().getMaxSmallFileSize(),
				(float)gri.getSingleClientResults().getSmallFileRecordSize(), "write");
		plot.plotVaryingFileSize(gri.getRegressionName(),
				(float)gri.getSingleClientResults().getMinSmallFileSize(),
				(float)gri.getSingleClientResults().getMaxSmallFileSize(),
				(float)gri.getSingleClientResults().getSmallFileRecordSize(), "read");
		
		
		plot.plotVaryingFileSize(cmd.getRegOneName(),cmd.getRegTwoName(),
				(float)cmd.getSingleClientResults().getMinSmallFileSize(), 
				(float)cmd.getSingleClientResults().getMaxSmallFileSize(),
				(float)cmd.getSingleClientResults().getSmallFileRecordSize(), "write");
		plot.plotVaryingFileSize(cmd.getRegOneName(),cmd.getRegTwoName(),
				(float)cmd.getSingleClientResults().getMinSmallFileSize(), 
				(float)cmd.getSingleClientResults().getMaxSmallFileSize(),
				(float)cmd.getSingleClientResults().getSmallFileRecordSize(), "read");
		
		plot.plotMultipleClientReport(gri.getRegressionName(), 
				gri.getMultipleCLientResults().getMinNumberOfClients(),
				gri.getMultipleCLientResults().getMaxNumberOfClients(),
				64,4);
		
		plot.plotMultipleClientReport(cmd.getRegOneName(), cmd.getRegTwoName(), 
				cmd.getMultipleCLientResults().getMinNumberOfClients(),
				cmd.getMultipleCLientResults().getMaxNumberOfClients(),
				64,4); 
				*/
	}

}
