#!/bin/bash
# Description: This file is the Disk performance diagnostic test script for 
# the pNFS regression suite and performance debugging tool chain. 
# Stage: 0 
# Author: Zainul Abedin (zja) & Swaroop Choudhari (svchoudh)
# Inputs: \
# Detailed Description: 
# Stage0 of the test suite is used to get Experimental setup information. 

count="0"
declare -a disks
i=0

if (([ -s "$storage_nodes_list" ]) && ([ -r "$storage_nodes_list" ]))
then
    if (([ -s "$disk_list" ]) && ([ -r "$disk_list" ]))
	then
	for disk in `cat "$disk_list"`; do
	    disks[i]=$disk
	    let "i=$i+1"
	done
    else
	disk_path='/dev/hda'
    fi
    
    element_count=${#disks[*]}
    
    echo "Taking disk statistics on all storage nodes"

    dsh -g storage_nodes -c -- " rm -rf "$PATH_TO_SAVE"diskstatistics_*.txt"

    if [ $DISK_PERFORMANCE -ne 0 ];then 
	let "i=0"
	for storage_node in `cat "$storage_nodes_list"`; do
	    echo $storage_node
	    let "count=0"
	    while [ "$count" -lt "$num_runs" ]; do
		if [ "$element_count" -eq "0" ]
		    then
		    dsh -m $storage_node -- "hdparm -t -T $disk_path >> "$PATH_TO_SAVE"diskstatistics_\`date +%m_%d_%Y_\`"$storage_node".txt" 
		else
		    dsh -m $storage_node -- "hdparm -t -T ${disks[$i]} >> "$PATH_TO_SAVE"diskstatistics_\`date +%m_%d_%Y_\`"$storage_node".txt" 
		fi
		let "count=$count+1"
	    done
	    let "i=$i+1"
	done
	
    
	
	for storage_node in `cat "$storage_nodes_list"`; do
	    temp="$SAVE_AS"
	    echo $temp
	    dsh -m $storage_node -- "cat "$PATH_TO_SAVE"diskstatistics_\`date +%m_%d_%Y_\`"$storage_node".txt | awk -f /usr/bin/disk_perf.awk  > /tmp/disk_perf_temp.txt && insert_disk_perf $DB_SERVER $num_runs $storage_node \"$temp\" && rm -rf "$PATH_TO_SAVE"diskstatistics_\`date +%m_%d_%Y_\`"$storage_node".txt && rm -rf /tmp/disk_perf_temp.txt"
	done
    fi
    exit
else
    echo "STAGE0-DIAGNOSIS PHASE:  DISK STATISTICS- Invalid file:" $storage_nodes_list
    exit
fi
